#-----------------------------------------------------------------------------
%{?!dist:	%define		dist	.ok}
%global		libname		solv
%global		rubyver		3.3.0
%global		perlvers	%(perl -v | awk '/This/ {print $9}' | sed -e 's/v//' | cut -d'(' -f2 | cut -d')' -f1 )
#-----------------------------------------------------------------------------
Name		:	libsolv
Version		:	0.7.27
Release		:	17.0.10.rel%{?dist}
Summary		:	Package dependency solver

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	BSD
URL		:	https://github.com/openSUSE/libsolv

Source0		:	%{name}-%{version}.tar.gz
#-----------------------------------------------------------------------------
BuildRequires	:	bzip2
BuildRequires	:	cmake
BuildRequires	:	gcc
BuildRequires	:	ninja
Buildrequires	:	rpm-devel
Buildrequires	:	zlib-devel
Buildrequires	:	xz-devel

Requires	:	rpm
#-----------------------------------------------------------------------------
%description
A free package dependency solver using a satisfiability algorithm. The
library is based on two major, but independent, blocks:
 
- Using a dictionary approach to store and retrieve package
  and dependency information.
 
- Using satisfiability, a well known and researched topic, for
  resolving package dependencies.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%license LICENSE*
%doc README
%{_libdir}/%{name}.so.*
%{_libdir}/%{name}ext.so.*

#=============================================================================
%package		devel
Summary		:       Development files for %{name}

Requires	:	%{name}		=	%{version}-%{release}
Requires	:	rpm

#-----------------------------------------------------------------------------
%description		devel
Development files for %{name}.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/%{libname}/*.h
%{_libdir}/%{name}.so
%{_libdir}/%{name}ext.so
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir}/pkgconfig/%{name}ext.pc
%dir %{_datadir}/cmake/Modules/
%{_datadir}/cmake/Modules/FindLibSolv.cmake
%{_mandir}/man3/%{name}*.3.gz

#=============================================================================
%package		tools
Summary		:       Package dependency solver tools

Requires	:	%{name}		=	%{version}-%{release}
Requires	:	/bin/find

#-----------------------------------------------------------------------------
%description		tools
Package dependency solver tools.

#-----------------------------------------------------------------------------
%files			tools
%defattr(-,root,root,-)
%{_bindir}/comps2solv
%{_bindir}/deltainfoxml2solv
%{_bindir}/dumpsolv
%{_bindir}/helix2solv
%{_bindir}/installcheck
%{_bindir}/mergesolv
%{_bindir}/repomdxml2solv
%{_bindir}/rpmdb2solv
%{_bindir}/rpmmd2solv
%{_bindir}/rpms2solv
%{_bindir}/testsolv
%{_bindir}/repo2solv
%{_bindir}/updateinfoxml2solv
%{_mandir}/man1/deltainfoxml2solv.1.gz
%{_mandir}/man1/comps2solv.1.gz
%{_mandir}/man1/dumpsolv.1.gz
%{_mandir}/man1/helix2solv.1.gz
%{_mandir}/man1/installcheck.1.gz
%{_mandir}/man1/mergesolv.1.gz
%{_mandir}/man1/repomdxml2solv.1.gz
%{_mandir}/man1/rpmdb2solv.1.gz
%{_mandir}/man1/rpmmd2solv.1.gz
%{_mandir}/man1/rpms2solv.1.gz
%{_mandir}/man1/repo2solv.1.gz
%{_mandir}/man1/testsolv.1.gz
%{_mandir}/man1/updateinfoxml2solv.1.gz

#=============================================================================
%package		demo
Summary		:       Applications demoing the %{name} library

Requires	:	%{name}		=	%{version}-%{release}
Requires	:	%{_bindir}/curl
Requires	:	%{_bindir}/gpg2

#-----------------------------------------------------------------------------
%description		demo
Applications demoing the %{name} library.

#-----------------------------------------------------------------------------
%files			demo
%defattr(-,root,root,-)
%{_mandir}/man1/solv.1.gz

#=============================================================================
%package -n		perl-%{libname}
Summary		:       perl bindings for the %{name} library

BuildRequires	:	swig
BuildRequires	:	perl

#-----------------------------------------------------------------------------
%description -n		perl-%{libname}
Perl bindings for the %{name} library.

#-----------------------------------------------------------------------------
%files -n		perl-%{libname}
%defattr(-,root,root,-)
%{_libdir}/perl5/%{perlvers}/vendor_perl/solv.pm
%{_libdir}/perl5/%{perlvers}/vendor_perl/solv.so

#=============================================================================
%package -n		ruby-%{libname}
Summary		:       Ruby bindings for the %{name} library

BuildRequires	:	swig
BuildRequires	:	ruby

#-----------------------------------------------------------------------------
%description -n		ruby-%{libname}
Ruby bindings for the %{name} library.

#-----------------------------------------------------------------------------
%files -n		ruby-%{libname}
%defattr(-,root,root,-)
%{_libdir}/ruby/vendor_ruby/%{rubyver}/%{_arch}-linux/%{libname}.so

#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
%build
cmake							\
	-S .						\
	-B _bld						\
	-D CMAKE_INSTALL_PREFIX=%{_prefix}		\
	-D CMAKE_INSTALL_LIBDIR=%{_libdir}		\
	-D ENABLE_RPMDB=ON				\
	-D ENABLE_RPMDB_BYRPMHEADER=ON 			\
	-D ENABLE_RPMDB_LIBRPM=ON			\
	-D ENABLE_RPMPKG_LIBRPM=ON			\
	-D ENABLE_RPMMD=ON				\
	-D ENABLE_COMPS=ON				\
	-D ENABLE_HELIXREPO=ON				\
	-D ENABLE_PUBKEY=ON				\
	-D USE_VENDORDIRS=ON				\
	-D WITH_LIBXML2=ON				\
	-D ENABLE_LZMA_COMPRESSION=ON			\
	-D ENABLE_BZIP2_COMPRESSION=ON			\
	-D ENABLE_ZSTD_COMPRESSION=ON			\
	-D ENABLE_ZCHUNK_COMPRESSION=ON			\
	-D ENABLE_COMPLEX_DEPS=1			\
	-D MULTI_SEMANTICS=ON				\
	-D ENABLE_PERL=ON				\
	-D ENABLE_RUBY=ON				\

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#osukiss directory information
#-----------------------------------------------------------------------------
%check

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}							\
	-C _bld							\
	DESTDIR=%{buildroot}					\
	install

#-----------------------------------------------------------------------------
%changelog
